// Author: Professor William Killian
// Date: 2019 June 4
// Class: CSCI 362.93 - Data Structures
// Assignment: 4 - Stacks and Queues
//
// Description:
// Unit Test Runner for student-written Stack and Queue

#include <cstdlib>
#include <regex>
#include <vector>

#include "support/catch_config.hpp"

#include "support/catch.hpp"

#include "TestQueue.hpp"
#include "TestStack.hpp"

static std::regex const regex{
  "[ \t]*(When|Then|Scenario|Given|And):[ \t]*\\[([0-9]*)\\].*",
  std::regex::optimize};

struct AutolabListener : Catch::TestEventListenerBase
{

  static std::string json;
  std::vector<std::string> testStack;
  int incorrect = 0;
  int points = 0;

  using TestEventListenerBase::TestEventListenerBase; // inherit constructor

  virtual void
  sectionStarting (Catch::SectionInfo const& sectionInfo) override
  {
    testStack.push_back (sectionInfo.name);
  }

  virtual void
  sectionEnded (Catch::SectionStats const& sectionStats) override
  {
    std::string top = testStack.back ();
    std::smatch sm;
    if (std::regex_match (top, sm, regex))
    {
      int value = std::atoi (sm.str (2).c_str ());
      if (!sectionStats.assertions.allOk())
      {
        incorrect += value;
      }
      points += value;
    }
    testStack.pop_back ();
  }

  virtual void
  testRunEnded (Catch::TestRunStats const& testRunStats) override
  {
    std::ostringstream oss;
    oss << "Points: " << points << '\n';
    oss << "Incorrect: " << incorrect << '\n';
    oss << '\n';
    oss << "{ \"scores\": {\"auto\": " << (points - incorrect) << " } }";
    json = oss.str ();
  }
};

std::string AutolabListener::json;

CATCH_REGISTER_LISTENER (AutolabListener)

int
main (int argc, char* argv[])
{
  Catch::Session ().run (argc, argv);
  std::cerr << AutolabListener::json << '\n';
}
