// Author: Professor William Killian
// Date: 2019 June 4
// Class: CSCI 362.93 - Data Structures
// Assignment: 4 - Stacks and Queues
//
// Description:
// Unit Tests for Queue

#include "Queue.hpp"

#include "support/catch_config.hpp"

#include "support/catch.hpp"

SCENARIO ("[1] An empty queue should be empty", "[queue]")
{
  GIVEN ("We have a default-constructed Queue")
  {
    Queue<int> q;
    THEN ("The size is zero")
    {
      REQUIRE (q.size () == 0);
    }
    AND_THEN ("The queue is empty")
    {
      REQUIRE (q.empty ());
    }
  }
}

SCENARIO ("[1] We should be able to add to a queue", "[queue]")
{
  GIVEN ("An empty queue")
  {
    Queue<int> q;
    WHEN ("We add a single element to a queue")
    {
      int const VALUE = 1;
      q.push (VALUE);
      THEN ("The size should increase")
      {
        REQUIRE (q.size () == 1);
      }
      AND_THEN ("The queue is no longer empty")
      {
        REQUIRE_FALSE (q.empty ());
      }
      AND_THEN ("The front() of the queue is the value inserted")
      {
        REQUIRE (q.front () == VALUE);
      }
      AND_THEN ("The back() of the queue is the value inserted")
      {
        REQUIRE (q.back () == VALUE);
      }
      AND_THEN ("front() and back() refer to the same element")
      {
        REQUIRE (std::addressof(q.back()) == std::addressof(q.front()));
      }
    }
  }
}
