// Author: Professor William Killian
// Date: 2019 June 4
// Class: CSCI 362.93 - Data Structures
// Assignment: 4 - Stacks and Queues
//
// Description:
// Unit Tests for Stack

#include "Stack.hpp"

#include "support/catch_config.hpp"

#include "support/catch.hpp"

SCENARIO ("[1] Stacks should be default-constructable", "[stack]")
{
  GIVEN ("We have a default-constructed Stack")
  {
    Stack<int> s;
    THEN ("The size is zero")
    {
      REQUIRE (s.size () == 0);
    }
    AND_THEN ("The stack is empty")
    {
      REQUIRE (s.empty ());
    }
  }
}

SCENARIO ("[1] Stack supports push()", "[stack]")
{
  GIVEN ("An empty stack")
  {
    Stack<int> s;
    WHEN ("We add a single element to a stack")
    {
      int const VALUE = 1;
      s.push (VALUE);
      THEN ("The size should increase")
      {
        REQUIRE (s.size () == 1);
      }
      AND_THEN ("The stack is no longer empty")
      {
        REQUIRE_FALSE (s.empty ());
      }
      AND_THEN ("The top() of the stack is the value inserted")
      {
        REQUIRE (s.top () == VALUE);
      }
      AND_THEN ("top() is reassignable")
      {
        int const NEW_VALUE = 2;
        s.top() = NEW_VALUE;
        REQUIRE (s.top() == NEW_VALUE);
      }
    }
  }
}
